import java.util.Set;
import java.util.HashSet;

public class Vorlesung {
  public int vorlNr;
  public String titel;
  public int sws;
  public Professor dozent;
  public Set<Vorlesung> voraussetzungen;
  
  private int anzahlHoerer;
  private int anzahlPruefungen;
  private int anzahlDurchgefallen;

  public Vorlesung(int vorlNr, String titel, int sws, Professor dozent) {
    this.vorlNr = vorlNr;
    this.titel = titel;
    this.sws = sws;
    this.dozent = dozent;
    
    voraussetzungen = new HashSet<Vorlesung>();
    
    dozent.leseVorlesung(this);
  }
  
  public void pruefen(Pruefung pruefung) {
    if (pruefung.note > 4.0) {
      anzahlDurchgefallen++;
    }
    anzahlPruefungen++;
  }
  
  public void erhoeheAnzahlHoerer() {
    anzahlHoerer++;
  }
  
  public int anzahlHoerer() {
    return anzahlHoerer;
  }
  
  public float durchfallQuote() {
    return (float)anzahlDurchgefallen/anzahlPruefungen;
  }
}